import { world } from "@minecraft/server";
import { ActionFormData, ModalFormData } from "@minecraft/server-ui";

function showIndex(player) {
    var indexBook = new ActionFormData()
        .title("Vampire craft: Diaries")
        .body("")
        .button("gui.button.vampire")
        .button("gui.button.vampire_original")
    indexBook.show(player).then(result => {
        switch (result.selection) {
            case 0:
                showVampires(player);
                break;
            case 1:
                showVampires_original(player);
                break;
        }
    });
}

function showVampires(player) {
    var indexBook = new ActionFormData()
        .title("")
        .body("")
        .button("gui.button.sobre")
        .button("gui.button.sniveis")
    indexBook.show(player).then(result => {
        switch (result.selection) {
            case 0:
                player.runCommand('tellraw @s {"rawtext":[{"translate":"gui.button.vampire.sobre.text"}]}');
                break;
            case 1:
                player.runCommand('tellraw @s {"rawtext":[{"translate":"gui.button.vampire.sniveis.text"}]}');
                break;
        }
    });
}

function showVampires_original(player) {
    var indexBook = new ActionFormData()
        .title("")
        .body("")
        .button("gui.button.sobre")
        .button("gui.button.sniveis")
    indexBook.show(player).then(result => {
        switch (result.selection) {
            case 0:
                player.runCommand('tellraw @s {"rawtext":[{"translate":"gui.button.vampire_original.sobre.text"}]}');
                break;
            case 1:
                player.runCommand('tellraw @s {"rawtext":[{"translate":"gui.button.vampire.sniveis.text"}]}');
                break;
        }
    });
}



world.afterEvents.itemUse.subscribe(eventData => {
    if (eventData.itemStack.typeId == 'sunrise:vpd_book') {
        showIndex(eventData.source);
    }
});