import { world, system } from "@minecraft/server";
import { ActionFormData, ModalFormData } from "@minecraft/server-ui";

function showSkillSelect(player) {
    var form = new ModalFormData

    if (player.hasTag('vpd_plus')) {
        form.title("Vampire Skills §m+")
    } else {
        form.title("Vampire Skills")
    }

    form.dropdown("gui.modes_select", ["gui.modes_select.none", "gui.modes_select.human", "gui.modes_select.boost"], 0)

    var veloActual = getSkillActual(player, "velo")
    var veloMax = getSkillMax(player, "velo")
    form.slider({ translate: 'gui.skillvelo.select' }, 0, veloMax, 1, veloActual)

    var resisActual = getSkillActual(player, "resis")
    var resisMax = getSkillMax(player, "resis")
    form.slider({ translate: "gui.skillresis.select" }, 0, resisMax, 1, resisActual)

    var forcaActual = getSkillActual(player, "forca")
    var forcaMax = getSkillMax(player, "forca")
    form.slider({ translate: "gui.skillforca.select" }, 0, forcaMax, 1, forcaActual)

    var regeActual = getSkillActual(player, "rege")
    var regeMax = getSkillMax(player, "rege")
    form.slider({ translate: "gui.skillrege.select" }, 0, regeMax, 1, regeActual)

    form.show(player).then(result => {
        if (result.formValues[0] == 0) {
            player.runCommand("function actual_skill_clear")
            player.runCommandAsync("tag @s add vpd_actual_skill_velo_" + result.formValues[1])
            player.runCommandAsync("tag @s add vpd_actual_skill_resis_" + result.formValues[2])
            player.runCommandAsync("tag @s add vpd_actual_skill_forca_" + result.formValues[3])
            player.runCommandAsync("tag @s add vpd_actual_skill_rege_" + result.formValues[4])
        }
        else if (result.formValues[1]) {
            player.runCommand("function actual_skill_clear")
            player.runCommandAsync("tag @s add vpd_actual_skill_velo_" + 1)
            player.runCommandAsync("tag @s add vpd_actual_skill_resis_" + 1)
            player.runCommandAsync("tag @s add vpd_actual_skill_forca_" + 1)
            player.runCommandAsync("tag @s add vpd_actual_skill_rege_" + 1)
        }
        else if (result.formValues[2]) {
            player.runCommand("function actual_skill_clear")
            player.runCommandAsync("tag @s add vpd_actual_skill_velo_" + veloMax)
            player.runCommandAsync("tag @s add vpd_actual_skill_forca_" + forcaMax)
            player.runCommandAsync("tag @s add vpd_actual_skill_rege_" + regeMax)
            player.runCommandAsync("tag @s add vpd_actual_skill_resis_" + resisMax)
        }
    })
}

function getSkillActual(player, skill) {
    if (player.hasTag('vpd_actual_skill_' + skill + '_1')) {
        return 1
    } else if (player.hasTag('vpd_actual_skill_' + skill + '_2')) {
        return 2
    } else if (player.hasTag('vpd_actual_skill_' + skill + '_3')) {
        return 3
    } else if (player.hasTag('vpd_actual_skill_' + skill + '_4')) {
        return 4
    } else if (player.hasTag('vpd_actual_skill_' + skill + '_5')) {
        return 5
    } else if (player.hasTag('vpd_actual_skill_' + skill + '_6')) {
        return 6
    } else if (player.hasTag('vpd_actual_skill_' + skill + '_7')) {
        return 7
    } else if (player.hasTag('vpd_actual_skill_' + skill + '_8')) {
        return 8
    } else {
        return 0
    }

}

function getSkillMax(player, skill) {
    if (player.hasTag('vpd_skill_' + skill + '_1')) {
        return 1
    } else if (player.hasTag('vpd_skill_' + skill + '_2')) {
        return 2
    } else if (player.hasTag('vpd_skill_' + skill + '_3')) {
        return 3
    } else if (player.hasTag('vpd_skill_' + skill + '_4')) {
        return 4
    } else if (player.hasTag('vpd_skill_' + skill + '_5')) {
        return 5
    } else if (player.hasTag('vpd_skill_' + skill + '_6')) {
        return 6
    } else if (player.hasTag('vpd_skill_' + skill + '_7')) {
        return 7
    } else if (player.hasTag('vpd_skill_' + skill + '_8')) {
        return 8
    } else {
        return 1
    }
}

function vpd_unlockSkill(player) {
    var form = new ActionFormData
    var veloMax = getSkillMax(player, "velo")
    var resisMax = getSkillMax(player, "resis")
    var forcaMax = getSkillMax(player, "forca")
    var regeMax = getSkillMax(player, "rege")
    form.button({ translate: "gui.skillforca.select" })
    form.button({ translate: "gui.skillresis.select" })
    form.button({ translate: 'gui.skillvelo.select' })
    form.button({ translate: "gui.skillrege.select" })
    if ((regeMax + forcaMax + resisMax + veloMax) <= 9 && player.hasTag("vpd_plus") == false) {
        form.show(player).then(result => {
            switch (result.selection) {
                case 0:
                    player.runCommandAsync('tag @s remove vpd_skill_forca_' + forcaMax)
                    player.runCommandAsync('tag @s add vpd_skill_forca_' + (forcaMax + 1))
                    break;
                case 1:
                    player.runCommandAsync('tag @s remove vpd_skill_resis_' + resisMax)
                    player.runCommandAsync('tag @s add vpd_skill_resis_' + (resisMax + 1))
                    break;
                case 2:
                    player.runCommandAsync('tag @s remove vpd_skill_velo_' + veloMax)
                    player.runCommandAsync('tag @s add vpd_skill_velo_' + (veloMax + 1))
                    break;
                case 3:
                    player.runCommandAsync('tag @s remove vpd_skill_rege_' + regeMax)
                    player.runCommandAsync('tag @s add vpd_skill_rege_' + (regeMax + 1))
                    break;
            }
        })
    } else if ((regeMax + forcaMax + resisMax + veloMax) <= 11 && player.hasTag("vpd_plus") == true) {
        form.show(player).then(result => {
            switch (result.selection) {
                case 0:
                    player.runCommandAsync('tag @s remove vpd_skill_forca_' + forcaMax)
                    player.runCommandAsync('tag @s add vpd_skill_forca_' + (forcaMax + 1))
                    break;
                case 1:
                    player.runCommandAsync('tag @s remove vpd_skill_resis_' + resisMax)
                    player.runCommandAsync('tag @s add vpd_skill_resis_' + (resisMax + 1))
                    break;
                case 2:
                    player.runCommandAsync('tag @s remove vpd_skill_velo_' + veloMax)
                    player.runCommandAsync('tag @s add vpd_skill_velo_' + (veloMax + 1))
                    break;
                case 3:
                    player.runCommandAsync('tag @s remove vpd_skill_rege_' + regeMax)
                    player.runCommandAsync('tag @s add vpd_skill_rege_' + (regeMax + 1))
                    break;
            }
        })
    }
}

world.afterEvents.itemUse.subscribe(eventData => {
    if (eventData.itemStack.typeId == 'sunrise:vpd_skill') {
        showSkillSelect(eventData.source);
    }
})

world.afterEvents.itemUse.subscribe(eventData => {
    if (eventData.source.hasTag("vpd")) {
        if (eventData.source.runCommand('testforblock ' + eventData.source.getBlockFromViewDirection().block.x + ' ' + eventData.source.getBlockFromViewDirection().block.y + ' ' + eventData.source.getBlockFromViewDirection().block.z + ' sunrise:caixao_acacia').successCount == 1 || eventData.source.runCommand('testforblock ' + eventData.source.getBlockFromViewDirection().block.x + ' ' + eventData.source.getBlockFromViewDirection().block.y + ' ' + eventData.source.getBlockFromViewDirection().block.z + ' sunrise:caixao_oak').successCount == 1 || eventData.source.runCommand('testforblock ' + eventData.source.getBlockFromViewDirection().block.x + ' ' + eventData.source.getBlockFromViewDirection().block.y + ' ' + eventData.source.getBlockFromViewDirection().block.z + ' sunrise:caixao_birch').successCount == 1 || eventData.source.runCommand('testforblock ' + eventData.source.getBlockFromViewDirection().block.x + ' ' + eventData.source.getBlockFromViewDirection().block.y + ' ' + eventData.source.getBlockFromViewDirection().block.z + ' sunrise:caixao_crimson').successCount == 1 || eventData.source.runCommand('testforblock ' + eventData.source.getBlockFromViewDirection().block.x + ' ' + eventData.source.getBlockFromViewDirection().block.y + ' ' + eventData.source.getBlockFromViewDirection().block.z + ' sunrise:caixao_jungle').successCount == 1 || eventData.source.runCommand('testforblock ' + eventData.source.getBlockFromViewDirection().block.x + ' ' + eventData.source.getBlockFromViewDirection().block.y + ' ' + eventData.source.getBlockFromViewDirection().block.z + ' sunrise:caixao_spruce').successCount == 1 || eventData.source.runCommand('testforblock ' + eventData.source.getBlockFromViewDirection().block.x + ' ' + eventData.source.getBlockFromViewDirection().block.y + ' ' + eventData.source.getBlockFromViewDirection().block.z + ' sunrise:caixao_warped').successCount == 1) {
            eventData.source.runCommandAsync("spawnpoint @s[r=4] ~~1~")
            eventData.source.runCommandAsync("camera @s[r=8] fade time 0.4 1.8 0.75 color 0 0 0")
            eventData.source.runCommandAsync("time set night")
            if (eventData.source.hasTag("vpd_runlucks")) {
                vpd_unlockSkill(eventData.source)
                eventData.source.runCommandAsync("tag @s remove vpd_runlucks")
            }
        }
    }
})